Attribute VB_Name = "DirectX"
Public Dx7 As New DirectX7
Public DDraw As DirectDraw7
Public Primary As DirectDrawSurface7
Public PrimaryDesc As DDSURFACEDESC2
Public BackBuffer As DirectDrawSurface7
Public BackBufferDesc As DDSURFACEDESC2

Public ItemColorKey As DDCOLORKEY

Public Objet(1 To 1000) As DirectDrawSurface7
Public ObjetDesc(1 To 1000) As DDSURFACEDESC2
Public NB_objets As Integer
Dim Affiche_Name(1 To 1000) As String

Public Function DefineColorKey(Image As DirectDrawSurface7)

ItemColorKey.high = vbWhite
ItemColorKey.low = vbWhite
Image.SetColorKey DDCKEY_SRCBLT, ItemColorKey

End Function

Public Function InitTexture(Nom As DirectDrawSurface7, Chemin As String, Description As DDSURFACEDESC2)
Set Nom = DDraw.CreateSurfaceFromFile((Chemin), Description)
Call DefineColorKey(Nom)
End Function

Public Function InitDDraw(FormX As Form, ResolutionX As Integer, ResolutionY As Integer)

Set DDraw = Dx7.DirectDrawCreate("")
DDraw.SetCooperativeLevel FormX.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWMODEX
DDraw.SetDisplayMode ResolutionX, ResolutionY, 16, 0, DDSDM_DEFAULT
PrimaryDesc.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
PrimaryDesc.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_COMPLEX Or DDSCAPS_FLIP
PrimaryDesc.lBackBufferCount = 1
Set Primary = DDraw.CreateSurface(PrimaryDesc)
Dim Caps As DDSCAPS2
Caps.lCaps = DDSCAPS_BACKBUFFER
Set BackBuffer = Primary.GetAttachedSurface(Caps)
BackBuffer.GetSurfaceDesc BackBufferDesc
End Function

Public Function DDRect(X, Y, X1, Y1) As RECT

DDRect.Bottom = Y1
DDRect.Top = Y
DDRect.Left = X
DDRect.Right = X1

End Function

Public Function Fin()

Set DDraw = Nothing
Set Dx7 = Nothing
End

End Function

Public Function CLR(Optional Color As ColorConstants = vbBlack)
BackBuffer.BltColorFill DDRect(0, 0, 0, 0), Color
End Function

Public Function FLIP(FormX As Form)
If FormX.WindowState <> vbMinimized Then Primary.FLIP Nothing, DDFLIP_WAIT
End Function

Public Function Afficher(Image As String, X As Long, Y As Long, Optional X1 As Long = 0, Optional Y1 As Long = 0, Optional X2 As Long = 0, Optional Y2 As Long = 0)

Dim Search As Integer
For Search = 1 To NB_objets
    If Image = Affiche_Name(Search) Then
        BackBuffer.BltFast X, Y, Objet(Search), DDRect(X1, Y1, X2, Y2), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Exit Function
    End If
Next

End Function

Public Function Build(Chemin As String, Nom As String)

NB_objets = NB_objets + 1
If Dir$(Chemin) = "" Then Exit Function
Call InitTexture(Objet(NB_objets), Chemin, ObjetDesc(NB_objets))
Affiche_Name(NB_objets) = Nom
End Function


